package lab.game;

import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;
import javafx.scene.transform.Affine;
import javafx.scene.transform.Transform;

public class Cannon extends WorldEntity {

	private static final double LENGTH = 60;
	private static final double WIDTH = 15;
	private double angle;

	public Cannon(World world, MyPoint position, double angle) {
		super(world, position);
		this.angle = angle;
	}

	@Override
	public void drawInternal(GraphicsContext gc) {
		gc.transform(new Affine(Transform.rotate(angle, position.getX(), position.getY() + WIDTH / 2)));
		gc.setFill(Color.BROWN);
		gc.fillRect(position.getX(), position.getY(), LENGTH, WIDTH);
	}

	@Override
	public void simulate(double deltaT) {
		/* nothing to do */
	}

	public double getAngle() {
		return angle;
	}

	public void setAngle(double angle) {
		this.angle = -angle;
	}

}
