package jez04.structure.test;

import static org.hamcrest.MatcherAssert.assertThat;

import java.net.URISyntaxException;

import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvSource;

import cz.vsb.fei.kelvin.unittest.StructureHelper;
import cz.vsb.fei.kelvin.unittest.TextFileContains;

class ClassStructureTest {

	StructureHelper helper = StructureHelper.getInstance(ClassStructureTest.class);

	// @formatting:off
	@ParameterizedTest
	@CsvSource({
		".*\\.java,@Entity,2",
		".*\\.java,@OneToMany\\(mappedBy,1",
		".*\\.java,@ManyToOne,1",
		".*\\.java,@Id,2",
		".*\\.java,@GeneratedValue,2",
		".*\\.java,Persistence\\.createEntityManagerFactory,1",
		".*\\.java,emf.createEntityManager,1",
		".*\\.java,\\.persist\\(,1",
		".*\\.java,\\.getTransaction\\(\\),1",
		".*\\.java,.begin\\(\\),1",
		".*\\.java,.commit\\(\\),1",
	})
	// @formatting:on
	void anotaceTest(String file, String annotation, int count) throws URISyntaxException {
		assertThat(TextFileContains.getProjectRoot(getClass()),
				new TextFileContains(file, annotation).useRegExpForName(true).count(count));
	}


}
